#ifndef VARIANT
#define VARIANT 0
#endif

static ssize_t proc_node_read( char *buffer, char **start, off_t off,
                               int count, int *eof, void *data ) {
   int len = 0;
   LOG( "read: %d (buffer=%p, off=%ld, start=%p)", count, buffer, off, *start );

#if VARIANT == 0

   // тупо копируем весь буфер, пока return не станет <= off
   len = strlen( buf_msg );
   strcpy( buffer, buf_msg );
   LOG( "copy bytes: %d", len );

#elif VARIANT == 1

   // ... на 1 шаг раньше ( return == off ) установлен eof
   if( off < strlen( buf_msg ) ) {
      len = strlen( buf_msg );
      strcpy( buffer, buf_msg );
      LOG( "copy bytes: %d", len );
   }
   *eof = off + count >= strlen( buf_msg ) ? 1 : 0;

#elif VARIANT == 2

   // 1-но копирование всего буфера на 1-м запросе
   len = strlen( buf_msg );
   if( 0 == off ) {
      strcpy( buffer, buf_msg );
      LOG( "copy bytes: %d", len );
   }
   *eof = off + count >= strlen( buf_msg ) ? 1 : 0;

#elif VARIANT == 3

   // копирование только count байт на каждом запросе - аккуратно меняем return!
   if( off >= strlen( buf_msg ) ) {
      *eof = 1;
   }
   else {
      int cp;
      len = strlen( buf_msg + off );
      cp = min( count, len );
      strncpy( buffer + off, buf_msg + off, cp );
      LOG( "copy bytes: %d", cp );
      len = off + cp;
      *eof = off + cp >= strlen( buf_msg );
   }

#else 
#error недопустимый VARIANT !
#endif

   LOG( "return bytes: %d%s", len, *eof != 0 ? " ... EOF" : "" );
   return len;
};
